# implement LogFormatting

from TW.API import *
from time import time, strftime, localtime
from string import zfill, atoi
from re import sub
import sys


# Pre-defined format strings

FMT_SHORT = "%M"
FMT_MEDIUM = "[ %S ] %D: %M"
FMT_LONG = "%T %L %S - %M"
FMT_DEBUG = "%T (%D) %L %S - %M"

TIME_FORMAT = "%d.%m.%Y %H:%M:%S"





class LogService:

	def __init__(self,fname=None):
		__proceed__(self,fname)
		self._timeinit = time()
		self._formatstring = FMT_MEDIUM
		self._timeformat = TIME_FORMAT

	def setFormatString(self,fmt):
		self._formatstring = fmt

	def _showmessage(self,priority,sender,message):
		currenttime = time()
		timedifference = "%.3f" % (currenttime - self._timeinit)
		milliseconds = int(round((currenttime - long(currenttime)) * 1000))
		currenttime = strftime(self._timeformat, localtime(currenttime))
		currenttime = "%s.%s" % (currenttime, zfill(milliseconds, 3))

		# create message from formatstring

		msg = self._formatstring

		msg = sub("%S", sender, msg)
		msg = sub("%D", timedifference, msg)
		msg = sub("%L", LOG_MSG[priority], msg)
		msg = sub("%M", message, msg)
		msg = sub("%T", currenttime, msg)

		__proceed__(self,priority,sender,msg)
        
	
setupModule()
