# Implement LogLevels

from TW.API import *

# Logging levels

__all__ = ['LOGLEVEL_NONE',
           'LOGLEVEL_NORMAL',
           'LOGLEVEL_VERBOSE',
           'LOGLEVEL_DEBUG',
	   'LogService',
	  ]


LOGLEVEL_NONE = 1 << 0
LOGLEVEL_NORMAL = 1 << 1
LOGLEVEL_VERBOSE = 1 << 2
LOGLEVEL_DEBUG = 1 << 3


class LogService:

	def __init__(self,fname=None):
		__proceed__(self,fname)
		self._loglevel = LOGLEVEL_NORMAL	

	def setLogLevel(self,level):
		self._loglevel = level

	def debug(self,sender,message):
		if self._loglevel >= LOGLEVEL_DEBUG:
			__proceed__(self,sender,message)

	def warn(self,sender,message):
		if self._loglevel >= LOGLEVEL_VERBOSE:
			__proceed__(self,sender,message)

	def error(self,sender,message):
		if self._loglevel >= LOGLEVEL_NORMAL:
			__proceed__(self,sender,message)

	def info(self,sender,message):
		if self._loglevel >= LOGLEVEL_NORMAL:
			__proceed__(self,sender,message)

setupModule()
