#!/usr/bin/python

print "AOP-based Logging example"

def write_entries(l,m):
    l.info(m,'info message')
    l.error(m,'error message')
    l.warn(m,'warn message')
    l.debug(m,'debug message')



# Basic Logging

me = "BasicTest"
print me

from Logger import Logging

log = Logging.LogService()
write_entries(log,me)

# File Target

me = "FileTarget"
fname = './loggertest.log'
print me,fname

from Logger import BasicFileLogging

log = BasicFileLogging.LogService(fname)
write_entries(log,me)

# Syslog Target

me = "SyslogTarget"
print me

from Logger import BasicSyslogLogging

log = BasicSyslogLogging.LogService()
write_entries(log,me)


# Advanced Logging
print "AdvancedLogging"

me = "LogLevels"

from Logger import AdvancedLogging

log = AdvancedLogging.LogService()


print "set loglevel to NONE"
log.setLogLevel(AdvancedLogging.LOGLEVEL_NONE)
write_entries(log,me)

print "set loglevel to NORMAL"
log.setLogLevel(AdvancedLogging.LOGLEVEL_NORMAL)
write_entries(log,me)

print "set loglevel to VERBOSE"
log.setLogLevel(AdvancedLogging.LOGLEVEL_VERBOSE)
write_entries(log,me)

print "set loglevel to DEBUG"
log.setLogLevel(AdvancedLogging.LOGLEVEL_DEBUG)
write_entries(log,me)

me = "LogFormating"

print "set format to SHORT"
log.setFormatString(AdvancedLogging.FMT_SHORT)
write_entries(log,me)

print "set format to MEDIUM"
log.setFormatString(AdvancedLogging.FMT_MEDIUM)
write_entries(log,me)

print "set format to LONG"
log.setFormatString(AdvancedLogging.FMT_LONG)
write_entries(log,me)

print "set format to DEBUG"
log.setFormatString(AdvancedLogging.FMT_DEBUG)
write_entries(log,me)

# MyLogger

me = "MyLogger"
print me,' output goes to syslog'

from Logger import MyLogger

log = MyLogger.LogService()


log.setLogLevel(MyLogger.LOGLEVEL_NONE)
write_entries(log,me)

log.setLogLevel(MyLogger.LOGLEVEL_NORMAL)
write_entries(log,me)

log.setLogLevel(MyLogger.LOGLEVEL_VERBOSE)
write_entries(log,me)

log.setLogLevel(MyLogger.LOGLEVEL_DEBUG)
write_entries(log,me)

me = "LogFormating"

log.setFormatString(MyLogger.FMT_SHORT)
write_entries(log,me)

log.setFormatString(MyLogger.FMT_MEDIUM)
write_entries(log,me)

log.setFormatString(MyLogger.FMT_LONG)
write_entries(log,me)

log.setFormatString(MyLogger.FMT_DEBUG)
write_entries(log,me)

